/**
 * WRITE YOUR ANSWER TO PROBLEM 1.A HERE:
 * 
 * Baby has two states, which I will call "awake" and "asleep".   
 * The tryFeed() method causes Baby to switch from one state to the other.
 * 
 * ---------------------------------------------------
 * WRITE YOUR ANSWER TO PROBLEM 1.B HERE:
 * 
 * The getWeight() method is invariant as is the weight field 
 * as the baby always has a weight, no matter what state it is in.  
 * tryFeed() is variant because it's behavior depends on the baby's state.
 * tryFeed() modifies both the state and the weight value.
 * 
 */


public class Baby {
  private int _weight; // weight in ounces
  
  /**
   * Constructor for a Baby.
   * @param weight The baby's initial weight in ounces.
   */
  public Baby(int weight) {
    _weight = weight;
  }
  
  private interface IState {
    public String tryFeed();

  }

  
  private IState awakeState = new IState()  {    
    public String tryFeed() {
      _state = sleepState;
      _weight += 2;
      return "Slurp, slurp, slurp...";
    }   
  };
  
  private IState sleepState = new IState() { 
    public String tryFeed() {
      _state = awakeState;
      _weight -= 1;
      return "Waaaaa! Waaaaa!";
    }

  };
  
  private IState _state =  awakeState;
  
  /**
   * Try to feed the baby.
   * @return The noise that the baby makes when you try to feed it.
   */
  public String tryFeed() {
    return _state.tryFeed();
  }
  
  /**
   * Accessor method for the current weight of the baby.
   * @return  The current weight of the baby in ounces.
   */
  public int getWeight() {
    return _weight;
  }

}