package listFW.visitor.test;

import junit.framework.TestCase;
import listFW.*;
import listFW.visitor.*;
import listFW.factory.*;


/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class TestRunningSum extends TestCase {
  
  private static IListFactory fac = InnerCompListFact.Singleton;
  private static IListAlgo runSum = new RunningSum(fac);
  
  /**
   */
  public void testEmptyCase() {
    IList aList = fac.makeEmptyList();
    assertEquals("Running Sum of (): ", "()", aList.execute(runSum).toString());
  }
  
  /**
   */
  public void testNonEmptyCase() {
    IList aList = fac.makeEmptyList();
    aList = fac.makeNEList(5, aList);
    assertEquals("Running Sum of (5): ", "(5)", aList.execute(runSum).toString());
    aList = fac.makeNEList(10, aList);
    assertEquals("Running Sum of (10, 5): ", "(10, 15)", aList.execute(runSum).toString());
    aList = fac.makeNEList(-9, aList);
    assertEquals("Running Sum of (-9, 10, 5): ", "(-9, 1, 6)", aList.execute(runSum).toString());
  }
}
