package lrs.visitor.test;

import junit.framework.TestCase;
import lrs.*;
import lrs.visitor.*;


/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class TestRunningSum extends TestCase {
    private static IAlgo runSum = RunningSum.Singleton;
    
    /**
     */
    public void testEmptyCase() {
        LRStruct aList = new LRStruct();
        aList.execute(runSum);
        assertEquals("Running Sum of (): ", "()", aList.toString());
    }
    
    /**
     */
    public void testNonEmptyCase() {
        LRStruct aList = new LRStruct();
        aList.insertFront(5);
        aList.execute(runSum);
        assertEquals("Running Sum of (5): ", "(5)", aList.toString());
        aList.insertFront(10);
        aList.execute(runSum);
        assertEquals("Running Sum of (10 5): ", "(10 15)", aList.toString());
        aList.insertFront(-9);
        aList.execute(runSum);
        assertEquals("Running Sum of (-9 10 15): ", "(-9 1 16)", aList.toString());
    }
}
