package lrs.visitor.test;

import junit.framework.TestCase;
import lrs.*;
import lrs.visitor.*;


/**
 * A JUnit test case class to test the Contain algorithm.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class TestContain extends TestCase {
    private static IAlgo contain = Contain.Singleton;
    
    /**
     */
    public void testEmptyCase() {
        LRStruct aList = new LRStruct();
        assertEquals("() contains 5: ", false, aList.execute(contain, 5));
    }
    
    /**
     */
    public void testNonEmptyCase() {
        LRStruct aList = new LRStruct();
        aList.insertFront(5);
        assertEquals("(5) contains 5: ", true, aList.execute(contain, 5));
        assertEquals("(5) contains 10: ", false, aList.execute(contain, 10));
        aList.insertFront("a");
        assertEquals("(a 5) contains 5: ", true, aList.execute(contain, 5));
        assertEquals("(a 5) contains a: ", true, aList.execute(contain, "a"));
        assertEquals("(a 5) contains 99: ", false, aList.execute(contain, 99));
    }
}
