package lrs.visitor.test;

import junit.framework.TestCase;
import lrs.*;
import lrs.visitor.*;


/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class TestRemDupFwd extends TestCase {
    private static IAlgo remDup = RemDupFwd.Singleton;
    
    /**
     */
    public void testEmptyCase() {
        LRStruct aList = new LRStruct();
        assertEquals("() remDup: ", "()", aList.execute(remDup).toString());
    }
    
    /**
     */
    public void testNonEmptyCase() {
        LRStruct aList = new LRStruct();
        aList.insertFront(5);
        assertEquals("(5) remDups: ", "(5)", aList.execute(remDup).toString());
        aList.insertFront(5);
        assertEquals("(5 5) remDups: ", "(5)", aList.execute(remDup).toString());
        aList.insertFront(10);
        assertEquals("(10 5) remDups: ", "(10 5)", aList.execute(remDup).toString());
        aList.insertFront("a");
        aList.insertFront(5);
        aList.insertFront(10);
        aList.insertFront(5);
        aList.insertFront("a");
        aList.insertFront(5);
        aList.insertFront(99);
        assertEquals("(99 5 a 5 10 5 a 10 5) remDups: ", "(99 5 a 10)", aList.execute(remDup).toString());
    }
}
